"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Snippets_1 = require("./Snippets");
var TagManager = {
    dataScript: function (dataLayer) {
        var script = document.createElement('script');
        script.innerHTML = dataLayer;
        return script;
    },
    gtm: function (args) {
        var snippets = Snippets_1.default.tags(args);
        var noScript = function () {
            var noscript = document.createElement('noscript');
            noscript.innerHTML = snippets.iframe;
            return noscript;
        };
        var script = function () {
            var script = document.createElement('script');
            script.innerHTML = snippets.script;
            return script;
        };
        var dataScript = this.dataScript(snippets.dataLayerVar);
        return {
            noScript: noScript,
            script: script,
            dataScript: dataScript
        };
    },
    initialize: function (_a) {
        var gtmId = _a.gtmId, _b = _a.events, events = _b === void 0 ? {} : _b, dataLayer = _a.dataLayer, _c = _a.dataLayerName, dataLayerName = _c === void 0 ? 'dataLayer' : _c, _d = _a.auth, auth = _d === void 0 ? '' : _d, _e = _a.preview, preview = _e === void 0 ? '' : _e;
        var gtm = this.gtm({
            id: gtmId,
            events: events,
            dataLayer: dataLayer || undefined,
            dataLayerName: dataLayerName,
            auth: auth,
            preview: preview
        });
        if (dataLayer)
            document.head.appendChild(gtm.dataScript);
        document.head.insertBefore(gtm.script(), document.head.childNodes[0]);
        document.body.insertBefore(gtm.noScript(), document.body.childNodes[0]);
    },
    dataLayer: function (_a) {
        var dataLayer = _a.dataLayer, _b = _a.dataLayerName, dataLayerName = _b === void 0 ? 'dataLayer' : _b;
        var newWindow = window;
        if (newWindow[dataLayerName])
            return newWindow[dataLayerName].push(dataLayer);
        var snippets = Snippets_1.default.dataLayer(dataLayer, dataLayerName);
        var dataScript = this.dataScript(snippets);
        document.head.insertBefore(dataScript, document.head.childNodes[0]);
    }
};
exports.default = TagManager;
